#
# Copyright (c) 2004 SASADA Koichi <ko1 at atdot.net>
#
# This program is free software with ABSOLUTELY NO WARRANTY.
# You can re-distribute and/or modify this program under
# the same terms of the Ruby's lisence.
#
#
# $Id: ndk_bot.rb,v 1.12 2004/04/22 17:47:29 ko1 Exp $
# Create : K.S. 04/04/19 00:39:48
#
#
# To make bot for nadoka, see this code.
#

module Nadoka

  class NDK_BotBreak < NDK_Error
  end
  
  class NDK_Bot
    Cmd = Nadoka::Cmd
    Rpl = Nadoka::Rpl
    
    def initialize manager, config
      @manager = manager
      @config  = config
      @state   = manager.state
      @raw_prefix = nil
      bot_initialize
    end
    attr_accessor :raw_prefix

    # To initialize bot insntace, please overide this.
    def bot_initialize
      # override me
    end

    # This method will be called when reload configuration.
    def bot_desctruct

    end

    # To access bot confiuration, please use this.
    #
    # in configuration file, 
    # BotConfig = {
    #   :BotClassName => {
    #     ... # you can access this value
    #   }
    # }
    # 
    def config
      @config.botconfig[self.class.name.intern] || {}
    end

    # Mostly, you need this method.
    def send_notice ch, msg
      msg = Cmd.notice(ch, msg)
      @manager.send_to_server  msg
      @manager.send_to_clients_otherwise msg, nil
    end

    # Usualy, you must not use this
    def send_privmsg ch, msg
      msg = Cmd.privmsg(ch, msg)
      @manager.send_to_server  msg
      @manager.send_to_clients_otherwise msg, nil
    end

    # Change user's mode as 'mode' on ch.
    def change_mode ch, mode, user
      send_msg Cmd.mode(ch, mode, user)
    end

    # Change your nick to 'nick'.
    def change_nick nick
      send_msg Cmd.nick(nick)
    end

    # Send command or reply(?) to server.
    def send_msg msg
      @manager.send_to_server msg
    end

=begin
    # ...
    # def on_[IRC Command or Reply(3 digits)] prefix(nick only), param1, param2, ...
    #   
    # end
    #

    # like these
    def on_privmsg user, ch, msg
      
    end
    
    def on_join user, ch
      
    end
    
    def on_part user, ch, msg=''
      
    end
    
    def on_quit user, ch
      
    end
    
    def on_xxx

    end

    # It's special event that will be called about a minute.
    def on_timer timeobj
      # do something
    end

    # It's special event that will be called when new client join.
    def on_client_login client_count
      # do something
    end

    # It's special event that will be called when a client part.
    def on_client_logout client_count
      # do something
    end

    
    You can access your current state on IRC server via @state.
    - @state.nick         # your current nick
    - @state.channels     # channels which you are join        ['ch1', 'ch2', ...]
    - @state.channel_users(ch) # channel users ['user1', ...]
    
=end

    def self.inherited subklass
      BotClass << subklass
    end
    
  end
end

